﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace PaylineMVC5.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Index(string price)
        {
            try
            {
                // در این قسمت میتوانید اطلاعات مورد نظر را در دیتابیس ذخیره کنید

                int saleOrderId = 1;
                string redirectPage = "http://localhost:23731/Home/Return?SaleOrderId=" + saleOrderId.ToString();

                //test Api
                string api = "adxcv-zzadq-polkjsad-opp13opoz-1sdf455aadzmck1244567";

                PayLine pay = new PayLine();

                double amount = double.Parse(price) * 10;

                string result = pay.Send("http://payline.ir/payment-test/gateway-send", api, amount, redirectPage);

                if (int.Parse(result) > 0)
                {
                    Response.Redirect("http://payline.ir/payment-test/gateway-" + result);
                }
                else
                {
                    switch (result)
                    {
                        case "-1":
                            ViewBag.Message = "api ارسالی با نوع api تعریف شده در payline ;'.سازگار نیست";
                            break;
                        case "-2":
                            ViewBag.Message = " مقدار amount ;'.داده عددي نمی باشد و یا کمتر از 1000 ریال است";
                            break;
                        case "-3":
                            ViewBag.Message = " مقدار redirect رشته null ;.است";
                            break;
                        case "-4":
                            ViewBag.Message = ".درگاهی با اطلاعات ارسالی شما یافت نشده و یا در حالت انتظار می باشد";
                            break;
                    }

                    ViewBag.Message = "مشکلی در برقراری ارتباط بوجود آمد لطفا بعدا تلاش کنید";


                }
            }
            catch
            {
                ViewBag.Message = "پاسخی از درگاه دریافت نشد";

            }
            return View();
        }

        public ActionResult Return(string saleOrderId)
        {
            try
            {
                string transId = Request.Form["trans_id"];
                string idGet = Request.Form["id_get"];
                string SaleOrderId = Request.QueryString["SaleOrderId"];

                if (!String.IsNullOrEmpty(transId) && !String.IsNullOrEmpty(idGet))
                {
                    PayLine GetPayline = new PayLine();

                    //test Api
                    string api = "adxcv-zzadq-polkjsad-opp13opoz-1sdf455aadzmck1244567";

                    //GetPayline.Get(url,"Your-API", trans_id, id_get)
                    string result = GetPayline.Get("http://payline.ir/payment-test/gateway-result-second", api, transId, idGet);

                    switch (result)
                    {
                        case "-1":
                            ViewBag.TransId = transId;
                            ViewBag.IdGet = idGet;
                            ViewBag.Message = "api ارسالی با نوع api تعریف شده در payline .سازگار نیست";
                            break;
                        case "-2":
                            ViewBag.TransId = transId;
                            ViewBag.IdGet = idGet;
                            ViewBag.Message = "trans_id .ارسال شده معتبر نمی باشد";
                            break;
                        case "-3":
                            ViewBag.TransId = transId;
                            ViewBag.IdGet = idGet;
                            ViewBag.Message = "id_get .ارسالی معتبر نمی باشد";
                            break;
                        case "-4":
                            ViewBag.TransId = transId;
                            ViewBag.IdGet = idGet;
                            ViewBag.Message = ".چنین تراکنشی در سیستم وجود ندارد و یا موفقیت آمیز نبوده است ";
                            break;
                        case "1":
                            ViewBag.TransId = transId;
                            ViewBag.IdGet = idGet;
                            ViewBag.Message = ".تراکنش موفقیت آمیز بوده است";
                            break;
                    }
                    // در این قسمت می توانید اطلاعات دریافتی را در دیتابیس ذخیره کنید
                }
                else
                {
                    ViewBag.Message = "دسترسی امکانپذیر نیست";
                }
            }
            catch
            {
                ViewBag.Message = "پاسخی دریافت نشد";
            }
            return View();
        }
    }
}